diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/tcp-socket-base.cc ns-3.39/src/internet/model/tcp-socket-base.cc
--- ns-3.38/src/internet/model/tcp-socket-base.cc	2023-03-16 20:54:23.624868600 -0700
+++ ns-3.39/src/internet/model/tcp-socket-base.cc	2023-07-05 14:23:47.861427500 -0700
@@ -27,8 +27,13 @@
 #include "tcp-socket-base.h"
 
 #include "ipv4-end-point.h"
+#include "ipv4-route.h"
+#include "ipv4-routing-protocol.h"
+#include "ipv4.h"
 #include "ipv6-end-point.h"
 #include "ipv6-l3-protocol.h"
+#include "ipv6-route.h"
+#include "ipv6-routing-protocol.h"
 #include "rtt-estimator.h"
 #include "tcp-congestion-ops.h"
 #include "tcp-header.h"
@@ -37,6 +42,7 @@
 #include "tcp-option-sack.h"
 #include "tcp-option-ts.h"
 #include "tcp-option-winscale.h"
+#include "tcp-rate-ops.h"
 #include "tcp-recovery-ops.h"
 #include "tcp-rx-buffer.h"
 #include "tcp-tx-buffer.h"
@@ -46,13 +52,6 @@
 #include "ns3/double.h"
 #include "ns3/inet-socket-address.h"
 #include "ns3/inet6-socket-address.h"
-#include "ns3/ipv4-interface-address.h"
-#include "ns3/ipv4-route.h"
-#include "ns3/ipv4-routing-protocol.h"
-#include "ns3/ipv4.h"
-#include "ns3/ipv6-route.h"
-#include "ns3/ipv6-routing-protocol.h"
-#include "ns3/ipv6.h"
 #include "ns3/log.h"
 #include "ns3/node.h"
 #include "ns3/object.h"
@@ -60,7 +59,6 @@
 #include "ns3/pointer.h"
 #include "ns3/simulation-singleton.h"
 #include "ns3/simulator.h"
-#include "ns3/tcp-rate-ops.h"
 #include "ns3/trace-source-accessor.h"
 #include "ns3/uinteger.h"
 
@@ -513,14 +511,14 @@
 }
 
 /* Inherit from Socket class: Returns error code */
-enum Socket::SocketErrno
+Socket::SocketErrno
 TcpSocketBase::GetErrno() const
 {
     return m_errno;
 }
 
 /* Inherit from Socket class: Returns socket type, NS3_SOCK_STREAM */
-enum Socket::SocketType
+Socket::SocketType
 TcpSocketBase::GetSocketType() const
 {
     return NS3_SOCK_STREAM;
@@ -709,7 +707,7 @@
         // a v4 address and re-call this function
         Inet6SocketAddress transport = Inet6SocketAddress::ConvertFrom(address);
         Ipv6Address v6Addr = transport.GetIpv6();
-        if (v6Addr.IsIpv4MappedAddress() == true)
+        if (v6Addr.IsIpv4MappedAddress())
         {
             Ipv4Address v4Addr = v6Addr.GetIpv4MappedAddress();
             return Connect(InetSocketAddress(v4Addr, transport.GetPort()));
@@ -786,7 +784,7 @@
 
     if (m_txBuffer->SizeFromSequence(m_tcb->m_nextTxSequence) > 0)
     { // App close with pending data must wait until all data transmitted
-        if (m_closeOnEmpty == false)
+        if (!m_closeOnEmpty)
         {
             m_closeOnEmpty = true;
             NS_LOG_INFO("Socket " << this << " deferring close, state " << TcpStateName[m_state]);
@@ -1596,13 +1594,9 @@
 TcpSocketBase::ReadOptions(const TcpHeader& tcpHeader, uint32_t* bytesSacked)
 {
     NS_LOG_FUNCTION(this << tcpHeader);
-    TcpHeader::TcpOptionList::const_iterator it;
-    const TcpHeader::TcpOptionList options = tcpHeader.GetOptionList();
 
-    for (it = options.begin(); it != options.end(); ++it)
+    for (const auto& option : tcpHeader.GetOptionList())
     {
-        const Ptr<const TcpOption> option = (*it);
-
         // Check only for ACK options here
         switch (option->GetKind())
         {
@@ -2881,6 +2875,11 @@
 void
 TcpSocketBase::DeallocateEndPoint()
 {
+    // note: it shouldn't be necessary to invalidate the callback and manually call
+    // TcpL4Protocol::RemoveSocket. Alas, if one relies on the endpoint destruction
+    // callback, there's a weird memory access to a free'd area. Harmless, but valgrind
+    // considers it an error.
+
     if (m_endPoint != nullptr)
     {
         CancelAllTimers();
@@ -3267,7 +3266,7 @@
     NS_LOG_FUNCTION(this);
 
     // update the history of sequence numbers used to calculate the RTT
-    if (isRetransmission == false)
+    if (!isRetransmission)
     { // This is the next expected one, just log at end
         m_history.emplace_back(seq, sz, Simulator::Now());
     }
@@ -4410,7 +4409,7 @@
         m_highRxMark = header.GetSequenceNumber();
         update = true;
     }
-    if (update == true)
+    if (update)
     {
         m_rWnd = receivedWindow;
         NS_LOG_LOGIC("updating rWnd to " << m_rWnd);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/tcp-tx-buffer.cc ns-3.39/src/internet/model/tcp-tx-buffer.cc
--- ns-3.38/src/internet/model/tcp-tx-buffer.cc	2023-03-16 20:54:23.624868600 -0700
+++ ns-3.39/src/internet/model/tcp-tx-buffer.cc	2023-07-05 14:23:47.861427500 -0700
@@ -23,7 +23,7 @@
 #include "ns3/abort.h"
 #include "ns3/log.h"
 #include "ns3/packet.h"
-#include "ns3/tcp-option-ts.h"
+#include "ns3/simulator.h"
 
 #include <algorithm>
 #include <iostream>
@@ -943,13 +943,13 @@
         // Search for the right iterator before calling IsLost()
         if (beginOfCurrentPacket >= seq)
         {
-            if ((*it)->m_lost == true)
+            if ((*it)->m_lost)
             {
                 NS_LOG_INFO("seq=" << seq << " is lost because of lost flag");
                 return true;
             }
 
-            if ((*it)->m_sacked == true)
+            if ((*it)->m_sacked)
             {
                 NS_LOG_INFO("seq=" << seq << " is not lost because of sacked flag");
                 return false;
@@ -991,7 +991,7 @@
         item = *it;
 
         // Condition 1.a , 1.b , and 1.c
-        if (item->m_retrans == false && item->m_sacked == false)
+        if (!item->m_retrans && !item->m_sacked)
         {
             if (item->m_lost)
             {
@@ -1166,7 +1166,7 @@
     Ptr<const Packet> current;
     SequenceNumber32 beginOfCurrentPacket = seq;
 
-    if ((*segment)->m_sacked == true)
+    if ((*segment)->m_sacked)
     {
         return false;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/tcp-westwood-plus.cc ns-3.39/src/internet/model/tcp-westwood-plus.cc
--- ns-3.38/src/internet/model/tcp-westwood-plus.cc	2023-03-16 20:54:23.624868600 -0700
+++ ns-3.39/src/internet/model/tcp-westwood-plus.cc	2023-07-05 14:23:47.861427500 -0700
@@ -32,9 +32,6 @@
 
 #include "tcp-westwood-plus.h"
 
-#include "rtt-estimator.h"
-#include "tcp-socket-base.h"
-
 #include "ns3/log.h"
 #include "ns3/simulator.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/udp-l4-protocol.cc ns-3.39/src/internet/model/udp-l4-protocol.cc
--- ns-3.38/src/internet/model/udp-l4-protocol.cc	2023-03-16 20:54:23.624868600 -0700
+++ ns-3.39/src/internet/model/udp-l4-protocol.cc	2023-07-05 14:23:47.861427500 -0700
@@ -21,25 +21,25 @@
 
 #include "ipv4-end-point-demux.h"
 #include "ipv4-end-point.h"
-#include "ipv4-l3-protocol.h"
+#include "ipv4-route.h"
+#include "ipv4.h"
 #include "ipv6-end-point-demux.h"
 #include "ipv6-end-point.h"
-#include "ipv6-l3-protocol.h"
+#include "ipv6-route.h"
+#include "ipv6.h"
 #include "udp-header.h"
 #include "udp-socket-factory-impl.h"
 #include "udp-socket-impl.h"
 
 #include "ns3/assert.h"
 #include "ns3/boolean.h"
-#include "ns3/ipv4-route.h"
-#include "ns3/ipv6-header.h"
-#include "ns3/ipv6-route.h"
-#include "ns3/ipv6.h"
 #include "ns3/log.h"
 #include "ns3/node.h"
-#include "ns3/object-vector.h"
+#include "ns3/object-map.h"
 #include "ns3/packet.h"
 
+#include <unordered_map>
+
 namespace ns3
 {
 
@@ -53,15 +53,18 @@
 TypeId
 UdpL4Protocol::GetTypeId()
 {
-    static TypeId tid = TypeId("ns3::UdpL4Protocol")
-                            .SetParent<IpL4Protocol>()
-                            .SetGroupName("Internet")
-                            .AddConstructor<UdpL4Protocol>()
-                            .AddAttribute("SocketList",
-                                          "The list of sockets associated to this protocol.",
-                                          ObjectVectorValue(),
-                                          MakeObjectVectorAccessor(&UdpL4Protocol::m_sockets),
-                                          MakeObjectVectorChecker<UdpSocketImpl>());
+    static TypeId tid =
+        TypeId("ns3::UdpL4Protocol")
+            .SetParent<IpL4Protocol>()
+            .SetGroupName("Internet")
+            .AddConstructor<UdpL4Protocol>()
+            .AddAttribute("SocketList",
+                          "A container of sockets associated to this protocol. "
+                          "The underlying type is an unordered map, the attribute name "
+                          "is kept for backward compatibility.",
+                          ObjectMapValue(),
+                          MakeObjectMapAccessor(&UdpL4Protocol::m_sockets),
+                          MakeObjectMapChecker<UdpSocketImpl>());
     return tid;
 }
 
@@ -135,9 +138,9 @@
 UdpL4Protocol::DoDispose()
 {
     NS_LOG_FUNCTION(this);
-    for (std::vector<Ptr<UdpSocketImpl>>::iterator i = m_sockets.begin(); i != m_sockets.end(); i++)
+    for (auto i = m_sockets.begin(); i != m_sockets.end(); i++)
     {
-        *i = nullptr;
+        i->second = nullptr;
     }
     m_sockets.clear();
 
@@ -167,7 +170,7 @@
     Ptr<UdpSocketImpl> socket = CreateObject<UdpSocketImpl>();
     socket->SetNode(m_node);
     socket->SetUdp(this);
-    m_sockets.push_back(socket);
+    m_sockets[m_socketIndex++] = socket;
     return socket;
 }
 
@@ -328,7 +331,7 @@
     }
 }
 
-enum IpL4Protocol::RxStatus
+IpL4Protocol::RxStatus
 UdpL4Protocol::Receive(Ptr<Packet> packet, const Ipv4Header& header, Ptr<Ipv4Interface> interface)
 {
     NS_LOG_FUNCTION(this << packet << header);
@@ -362,7 +365,7 @@
                                                                  interface);
     if (endPoints.empty())
     {
-        if (this->GetObject<Ipv6L3Protocol>())
+        if (this->GetObject<Ipv6>())
         {
             NS_LOG_LOGIC("  No Ipv4 endpoints matched on UdpL4Protocol, trying Ipv6 " << this);
             Ptr<Ipv6Interface> fakeInterface;
@@ -387,7 +390,7 @@
     return IpL4Protocol::RX_OK;
 }
 
-enum IpL4Protocol::RxStatus
+IpL4Protocol::RxStatus
 UdpL4Protocol::Receive(Ptr<Packet> packet, const Ipv6Header& header, Ptr<Ipv6Interface> interface)
 {
     NS_LOG_FUNCTION(this << packet << header.GetSource() << header.GetDestination());
@@ -547,4 +550,21 @@
     return m_downTarget6;
 }
 
+bool
+UdpL4Protocol::RemoveSocket(Ptr<UdpSocketImpl> socket)
+{
+    NS_LOG_FUNCTION(this << socket);
+
+    for (auto& socketItem : m_sockets)
+    {
+        if (socketItem.second == socket)
+        {
+            socketItem.second = nullptr;
+            m_sockets.erase(socketItem.first);
+            return true;
+        }
+    }
+    return false;
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/udp-l4-protocol.h ns-3.39/src/internet/model/udp-l4-protocol.h
--- ns-3.38/src/internet/model/udp-l4-protocol.h	2023-03-16 20:54:23.624868600 -0700
+++ ns-3.39/src/internet/model/udp-l4-protocol.h	2023-07-05 14:23:47.861427500 -0700
@@ -26,6 +26,7 @@
 #include "ns3/ptr.h"
 
 #include <stdint.h>
+#include <unordered_map>
 
 namespace ns3
 {
@@ -183,6 +184,14 @@
      */
     void DeAllocate(Ipv6EndPoint* endPoint);
 
+    /**
+     * \brief Remove a socket from the internal list
+     *
+     * \param socket socket to remove
+     * \return true if the socket has been removed
+     */
+    bool RemoveSocket(Ptr<UdpSocketImpl> socket);
+
     // called by UdpSocket.
     /**
      * \brief Send a packet via UDP (IPv4)
@@ -242,12 +251,12 @@
               Ptr<Ipv6Route> route);
 
     // inherited from Ipv4L4Protocol
-    enum IpL4Protocol::RxStatus Receive(Ptr<Packet> p,
-                                        const Ipv4Header& header,
-                                        Ptr<Ipv4Interface> interface) override;
-    enum IpL4Protocol::RxStatus Receive(Ptr<Packet> p,
-                                        const Ipv6Header& header,
-                                        Ptr<Ipv6Interface> interface) override;
+    IpL4Protocol::RxStatus Receive(Ptr<Packet> p,
+                                   const Ipv4Header& header,
+                                   Ptr<Ipv4Interface> interface) override;
+    IpL4Protocol::RxStatus Receive(Ptr<Packet> p,
+                                   const Ipv6Header& header,
+                                   Ptr<Ipv6Interface> interface) override;
 
     void ReceiveIcmp(Ipv4Address icmpSource,
                      uint8_t icmpTtl,
@@ -283,11 +292,13 @@
     void NotifyNewAggregate() override;
 
   private:
-    Ptr<Node> m_node;                //!< the node this stack is associated with
+    Ptr<Node> m_node;                //!< The node this stack is associated with
     Ipv4EndPointDemux* m_endPoints;  //!< A list of IPv4 end points.
     Ipv6EndPointDemux* m_endPoints6; //!< A list of IPv6 end points.
 
-    std::vector<Ptr<UdpSocketImpl>> m_sockets;       //!< list of sockets
+    std::unordered_map<uint64_t, Ptr<UdpSocketImpl>>
+        m_sockets;             //!< Unordered map of socket IDs and corresponding sockets
+    uint64_t m_socketIndex{0}; //!< Index of the next socket to be created
     IpL4Protocol::DownTargetCallback m_downTarget;   //!< Callback to send packets over IPv4
     IpL4Protocol::DownTargetCallback6 m_downTarget6; //!< Callback to send packets over IPv6
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/udp-socket-impl.cc ns-3.39/src/internet/model/udp-socket-impl.cc
--- ns-3.38/src/internet/model/udp-socket-impl.cc	2023-03-16 20:54:23.624868600 -0700
+++ ns-3.39/src/internet/model/udp-socket-impl.cc	2023-07-05 14:23:47.861427500 -0700
@@ -20,25 +20,24 @@
 #include "udp-socket-impl.h"
 
 #include "ipv4-end-point.h"
+#include "ipv4-header.h"
+#include "ipv4-packet-info-tag.h"
+#include "ipv4-route.h"
+#include "ipv4-routing-protocol.h"
+#include "ipv4.h"
 #include "ipv6-end-point.h"
+#include "ipv6-l3-protocol.h"
+#include "ipv6-packet-info-tag.h"
+#include "ipv6-route.h"
+#include "ipv6-routing-protocol.h"
+#include "ipv6.h"
 #include "udp-l4-protocol.h"
 
 #include "ns3/inet-socket-address.h"
 #include "ns3/inet6-socket-address.h"
-#include "ns3/ipv4-header.h"
-#include "ns3/ipv4-packet-info-tag.h"
-#include "ns3/ipv4-route.h"
-#include "ns3/ipv4-routing-protocol.h"
-#include "ns3/ipv4.h"
-#include "ns3/ipv6-l3-protocol.h"
-#include "ns3/ipv6-packet-info-tag.h"
-#include "ns3/ipv6-route.h"
-#include "ns3/ipv6-routing-protocol.h"
-#include "ns3/ipv6.h"
 #include "ns3/log.h"
 #include "ns3/node.h"
 #include "ns3/trace-source-accessor.h"
-#include "ns3/udp-socket-factory.h"
 
 #include <limits>
 
@@ -153,14 +152,14 @@
     m_udp = udp;
 }
 
-enum Socket::SocketErrno
+Socket::SocketErrno
 UdpSocketImpl::GetErrno() const
 {
     NS_LOG_FUNCTION(this);
     return m_errno;
 }
 
-enum Socket::SocketType
+Socket::SocketType
 UdpSocketImpl::GetSocketType() const
 {
     return NS3_SOCK_DGRAM;
@@ -177,6 +176,10 @@
 UdpSocketImpl::Destroy()
 {
     NS_LOG_FUNCTION(this);
+    if (m_udp)
+    {
+        m_udp->RemoveSocket(this);
+    }
     m_endPoint = nullptr;
 }
 
@@ -184,6 +187,10 @@
 UdpSocketImpl::Destroy6()
 {
     NS_LOG_FUNCTION(this);
+    if (m_udp)
+    {
+        m_udp->RemoveSocket(this);
+    }
     m_endPoint6 = nullptr;
 }
 
@@ -193,13 +200,11 @@
 {
     if (m_endPoint != nullptr)
     {
-        m_endPoint->SetDestroyCallback(MakeNullCallback<void>());
         m_udp->DeAllocate(m_endPoint);
         m_endPoint = nullptr;
     }
     if (m_endPoint6 != nullptr)
     {
-        m_endPoint6->SetDestroyCallback(MakeNullCallback<void>());
         m_udp->DeAllocate(m_endPoint6);
         m_endPoint6 = nullptr;
     }
@@ -390,7 +395,7 @@
 UdpSocketImpl::Close()
 {
     NS_LOG_FUNCTION(this);
-    if (m_shutdownRecv == true && m_shutdownSend == true)
+    if (m_shutdownRecv && m_shutdownSend)
     {
         m_errno = Socket::ERROR_BADF;
         return -1;
@@ -406,7 +411,7 @@
 UdpSocketImpl::Connect(const Address& address)
 {
     NS_LOG_FUNCTION(this << address);
-    if (InetSocketAddress::IsMatchingType(address) == true)
+    if (InetSocketAddress::IsMatchingType(address))
     {
         InetSocketAddress transport = InetSocketAddress::ConvertFrom(address);
         m_defaultAddress = Address(transport.GetIpv4());
@@ -415,7 +420,7 @@
         m_connected = true;
         NotifyConnectionSucceeded();
     }
-    else if (Inet6SocketAddress::IsMatchingType(address) == true)
+    else if (Inet6SocketAddress::IsMatchingType(address))
     {
         Inet6SocketAddress transport = Inet6SocketAddress::ConvertFrom(address);
         m_defaultAddress = Address(transport.GetIpv6());
@@ -457,7 +462,7 @@
 UdpSocketImpl::DoSend(Ptr<Packet> p)
 {
     NS_LOG_FUNCTION(this << p);
-    if ((m_endPoint == nullptr) && (Ipv4Address::IsMatchingType(m_defaultAddress) == true))
+    if (m_endPoint == nullptr && Ipv4Address::IsMatchingType(m_defaultAddress))
     {
         if (Bind() == -1)
         {
@@ -466,7 +471,7 @@
         }
         NS_ASSERT(m_endPoint != nullptr);
     }
-    else if ((m_endPoint6 == nullptr) && (Ipv6Address::IsMatchingType(m_defaultAddress) == true))
+    else if (m_endPoint6 == nullptr && Ipv6Address::IsMatchingType(m_defaultAddress))
     {
         if (Bind6() == -1)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/test/examples-to-run.py ns-3.39/src/internet/test/examples-to-run.py
--- ns-3.38/src/internet/test/examples-to-run.py	2023-03-16 20:54:23.628868600 -0700
+++ ns-3.39/src/internet/test/examples-to-run.py	2023-07-05 14:23:47.861427500 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/test/internet-stack-helper-test-suite.cc ns-3.39/src/internet/test/internet-stack-helper-test-suite.cc
--- ns-3.38/src/internet/test/internet-stack-helper-test-suite.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/src/internet/test/internet-stack-helper-test-suite.cc	2023-07-05 14:23:47.861427500 -0700
@@ -0,0 +1,158 @@
+/*
+ * Copyright (c) 2023 Universita' di Firenze
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Tommaso Pecorella <tommaso.pecorella@unifi.it>
+ */
+
+#include "ns3/internet-stack-helper.h"
+#include "ns3/log.h"
+#include "ns3/node.h"
+#include "ns3/test.h"
+
+#include <string>
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE("InternetStackHelperTestSuite");
+
+/**
+ * \ingroup internet-test
+ *
+ * \brief InternetStackHelper Test
+ */
+class InternetStackHelperTestCase : public TestCase
+{
+  public:
+    InternetStackHelperTestCase();
+
+  private:
+    void DoRun() override;
+    void DoTeardown() override;
+};
+
+InternetStackHelperTestCase::InternetStackHelperTestCase()
+    : TestCase("InternetStackHelperTestCase")
+{
+}
+
+void
+InternetStackHelperTestCase::DoRun()
+{
+    // Checks:
+    // 1. IPv4 only, add IPv4 + IPv6 (result, IPv4 + IPv6)
+    // 2. IPv6 only, add IPv4 + IPv6 (result, IPv4 + IPv6)
+    // 3. IPv4 + IPv6, add IPv4 + IPv6 (result, IPv4 + IPv6)
+
+    Ptr<Node> nodeIpv4Only = CreateObject<Node>();
+    Ptr<Node> nodeIpv6Only = CreateObject<Node>();
+    Ptr<Node> nodeIpv46 = CreateObject<Node>();
+
+    InternetStackHelper internet;
+
+    internet.SetIpv4StackInstall(true);
+    internet.SetIpv6StackInstall(false);
+    internet.Install(nodeIpv4Only);
+
+    internet.SetIpv4StackInstall(false);
+    internet.SetIpv6StackInstall(true);
+    internet.Install(nodeIpv6Only);
+
+    internet.SetIpv4StackInstall(true);
+    internet.SetIpv6StackInstall(true);
+    internet.Install(nodeIpv46);
+
+    // Check that the three nodes have only the intended IP stack.
+    NS_TEST_EXPECT_MSG_NE(nodeIpv4Only->GetObject<Ipv4>(),
+                          nullptr,
+                          "IPv4 not found on IPv4-only node (should have been there)");
+    NS_TEST_EXPECT_MSG_EQ(nodeIpv4Only->GetObject<Ipv6>(),
+                          nullptr,
+                          "IPv6 found on IPv4-only node (should not have been there)");
+
+    NS_TEST_EXPECT_MSG_EQ(nodeIpv6Only->GetObject<Ipv4>(),
+                          nullptr,
+                          "IPv4 found on IPv6-only node (should not have been there)");
+    NS_TEST_EXPECT_MSG_NE(nodeIpv6Only->GetObject<Ipv6>(),
+                          nullptr,
+                          "IPv6 not found on IPv6-only node (should have been there)");
+
+    NS_TEST_EXPECT_MSG_NE(nodeIpv46->GetObject<Ipv4>(),
+                          nullptr,
+                          "IPv4 not found on dual stack node (should have been there)");
+    NS_TEST_EXPECT_MSG_NE(nodeIpv46->GetObject<Ipv6>(),
+                          nullptr,
+                          "IPv6 not found on dual stack node (should have been there)");
+
+    // Now we install IPv4 and IPv6 on the IPv4-only node
+    // IPv4 is already there, no error should happen.
+    internet.Install(nodeIpv4Only);
+    // Now we install IPv4 and IPv6 on the IPv6-only node,
+    // IPv6 is already there, no error should happen.
+    internet.Install(nodeIpv6Only);
+    // Now we install IPv4 and IPv6 on the dual stack node
+    // IPv4 and IPv6 are already there, no error should happen.
+    internet.Install(nodeIpv46);
+
+    // Check that the three nodes have both IPv4 and IPv6.
+    NS_TEST_EXPECT_MSG_NE(
+        nodeIpv4Only->GetObject<Ipv4>(),
+        nullptr,
+        "IPv4 not found on IPv4-only, now dual stack node (should have been there)");
+    NS_TEST_EXPECT_MSG_NE(
+        nodeIpv4Only->GetObject<Ipv6>(),
+        nullptr,
+        "IPv6 not found on IPv4-only, now dual stack node (should have been there)");
+
+    NS_TEST_EXPECT_MSG_NE(
+        nodeIpv6Only->GetObject<Ipv4>(),
+        nullptr,
+        "IPv4 not found on IPv6-only, now dual stack node (should have been there)");
+    NS_TEST_EXPECT_MSG_NE(
+        nodeIpv6Only->GetObject<Ipv6>(),
+        nullptr,
+        "IPv6 not found on IPv6-only, now dual stack node (should have been there)");
+
+    NS_TEST_EXPECT_MSG_NE(nodeIpv46->GetObject<Ipv4>(),
+                          nullptr,
+                          "IPv4 not found on dual stack node (should have been there)");
+    NS_TEST_EXPECT_MSG_NE(nodeIpv46->GetObject<Ipv6>(),
+                          nullptr,
+                          "IPv6 not found on dual stack node (should have been there)");
+}
+
+void
+InternetStackHelperTestCase::DoTeardown()
+{
+    Simulator::Destroy();
+}
+
+/**
+ * \ingroup internet-test
+ *
+ * \brief InternetStackHelper TestSuite
+ */
+class InternetStackHelperTestSuite : public TestSuite
+{
+  public:
+    InternetStackHelperTestSuite()
+        : TestSuite("internet-stack-helper", UNIT)
+    {
+        AddTestCase(new InternetStackHelperTestCase(), TestCase::QUICK);
+    }
+};
+
+static InternetStackHelperTestSuite
+    g_internetStackHelperTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/test/ipv4-global-routing-test-suite.cc ns-3.39/src/internet/test/ipv4-global-routing-test-suite.cc
--- ns-3.38/src/internet/test/ipv4-global-routing-test-suite.cc	2023-03-16 20:54:23.628868600 -0700
+++ ns-3.39/src/internet/test/ipv4-global-routing-test-suite.cc	2023-07-05 14:23:47.865427500 -0700
@@ -940,7 +940,7 @@
 void
 Ipv4DynamicGlobalRoutingTestCase::SendData(uint8_t index)
 {
-    if (m_sendSocks[index].second == false)
+    if (!m_sendSocks[index].second)
     {
         return;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/test/ipv4-list-routing-test-suite.cc ns-3.39/src/internet/test/ipv4-list-routing-test-suite.cc
--- ns-3.38/src/internet/test/ipv4-list-routing-test-suite.cc	2023-03-16 20:54:23.628868600 -0700
+++ ns-3.39/src/internet/test/ipv4-list-routing-test-suite.cc	2023-07-05 14:23:47.865427500 -0700
@@ -20,7 +20,8 @@
 #include "ns3/ipv4-routing-protocol.h"
 #include "ns3/test.h"
 
-using namespace ns3;
+namespace ns3
+{
 
 /**
  * \ingroup internet-test
@@ -41,10 +42,10 @@
     bool RouteInput(Ptr<const Packet> p,
                     const Ipv4Header& header,
                     Ptr<const NetDevice> idev,
-                    UnicastForwardCallback ucb,
-                    MulticastForwardCallback mcb,
-                    LocalDeliverCallback lcb,
-                    ErrorCallback ecb) override
+                    const UnicastForwardCallback& ucb,
+                    const MulticastForwardCallback& mcb,
+                    const LocalDeliverCallback& lcb,
+                    const ErrorCallback& ecb) override
     {
         return false;
     }
@@ -93,10 +94,10 @@
     bool RouteInput(Ptr<const Packet> p,
                     const Ipv4Header& header,
                     Ptr<const NetDevice> idev,
-                    UnicastForwardCallback ucb,
-                    MulticastForwardCallback mcb,
-                    LocalDeliverCallback lcb,
-                    ErrorCallback ecb) override
+                    const UnicastForwardCallback& ucb,
+                    const MulticastForwardCallback& mcb,
+                    const LocalDeliverCallback& lcb,
+                    const ErrorCallback& ecb) override
     {
         return false;
     }
@@ -217,3 +218,5 @@
 
 static Ipv4ListRoutingTestSuite
     g_ipv4ListRoutingTestSuite; //!< Static variable for test initialization
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/test/ipv6-list-routing-test-suite.cc ns-3.39/src/internet/test/ipv6-list-routing-test-suite.cc
--- ns-3.38/src/internet/test/ipv6-list-routing-test-suite.cc	2023-03-16 20:54:23.628868600 -0700
+++ ns-3.39/src/internet/test/ipv6-list-routing-test-suite.cc	2023-07-05 14:23:47.865427500 -0700
@@ -21,7 +21,8 @@
 #include "ns3/ipv6-routing-protocol.h"
 #include "ns3/test.h"
 
-using namespace ns3;
+namespace ns3
+{
 
 /**
  * \ingroup internet-test
@@ -42,10 +43,10 @@
     bool RouteInput(Ptr<const Packet> p,
                     const Ipv6Header& header,
                     Ptr<const NetDevice> idev,
-                    UnicastForwardCallback ucb,
-                    MulticastForwardCallback mcb,
-                    LocalDeliverCallback lcb,
-                    ErrorCallback ecb) override
+                    const UnicastForwardCallback& ucb,
+                    const MulticastForwardCallback& mcb,
+                    const LocalDeliverCallback& lcb,
+                    const ErrorCallback& ecb) override
     {
         return false;
     }
@@ -108,10 +109,10 @@
     bool RouteInput(Ptr<const Packet> p,
                     const Ipv6Header& header,
                     Ptr<const NetDevice> idev,
-                    UnicastForwardCallback ucb,
-                    MulticastForwardCallback mcb,
-                    LocalDeliverCallback lcb,
-                    ErrorCallback ecb) override
+                    const UnicastForwardCallback& ucb,
+                    const MulticastForwardCallback& mcb,
+                    const LocalDeliverCallback& lcb,
+                    const ErrorCallback& ecb) override
     {
         return false;
     }
@@ -246,3 +247,5 @@
 
 static Ipv6ListRoutingTestSuite
     g_ipv6ListRoutingTestSuite; //!< Static variable for test initialization
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/test/tcp-endpoint-bug2211.cc ns-3.39/src/internet/test/tcp-endpoint-bug2211.cc
--- ns-3.38/src/internet/test/tcp-endpoint-bug2211.cc	2023-03-16 20:54:23.628868600 -0700
+++ ns-3.39/src/internet/test/tcp-endpoint-bug2211.cc	2023-07-05 14:23:47.865427500 -0700
@@ -119,7 +119,7 @@
 
     TypeId tid = TcpSocketFactory::GetTypeId();
     Ptr<Socket> sink = Socket::CreateSocket(node, tid);
-    if (m_v6 == false)
+    if (!m_v6)
     {
         sink->Bind(InetSocketAddress(Ipv4Address::GetAny(), 9));
     }
@@ -135,7 +135,7 @@
     source->Bind();
     source->SetConnectCallback(MakeCallback(&TcpEndPointBug2211Test::HandleConnect, this),
                                MakeNullCallback<void, Ptr<Socket>>());
-    if (m_v6 == false)
+    if (!m_v6)
     {
         source->Connect(InetSocketAddress(Ipv4Address::GetLoopback(), 9));
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/test/tcp-pacing-test.cc ns-3.39/src/internet/test/tcp-pacing-test.cc
--- ns-3.38/src/internet/test/tcp-pacing-test.cc	2023-03-16 20:54:23.628868600 -0700
+++ ns-3.39/src/internet/test/tcp-pacing-test.cc	2023-07-05 14:23:47.865427500 -0700
@@ -336,14 +336,7 @@
         // so add an additional m_segmentSize to bytesInFlight
         uint32_t soonBytesInFlight = m_bytesInFlight + m_segmentSize;
         bool canPacketBeSent = ((m_curCwnd - soonBytesInFlight) >= m_segmentSize);
-        if (!canPacketBeSent || (m_curCwnd == 0))
-        {
-            m_isFullCwndSent = true;
-        }
-        else
-        {
-            m_isFullCwndSent = false;
-        }
+        m_isFullCwndSent = (!canPacketBeSent || m_curCwnd == 0);
         m_nextPacketInterval = m_expectedInterval;
         NS_LOG_DEBUG("Next expected interval (s): " << m_nextPacketInterval.GetSeconds());
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/test/tcp-test.cc ns-3.39/src/internet/test/tcp-test.cc
--- ns-3.38/src/internet/test/tcp-test.cc	2023-03-16 20:54:23.628868600 -0700
+++ ns-3.39/src/internet/test/tcp-test.cc	2023-07-05 14:23:47.865427500 -0700
@@ -226,7 +226,7 @@
     memset(m_sourceRxPayload, 0, m_totalBytes);
     memset(m_serverRxPayload, 0, m_totalBytes);
 
-    if (m_useIpv6 == true)
+    if (m_useIpv6)
     {
         SetupDefaultSim6();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet-apps/model/dhcp-client.cc ns-3.39/src/internet-apps/model/dhcp-client.cc
--- ns-3.38/src/internet-apps/model/dhcp-client.cc	2023-03-16 20:54:23.608868600 -0700
+++ ns-3.39/src/internet-apps/model/dhcp-client.cc	2023-07-05 14:23:47.829427500 -0700
@@ -369,7 +369,7 @@
     NS_LOG_FUNCTION(this << header);
 
     m_offerList.push_back(header);
-    if (m_offered == false)
+    if (!m_offered)
     {
         m_discoverEvent.Cancel();
         m_offered = true;
